From b1679e5d473a914eda89358ba6db2a41f2fdf64d Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 27 Jun 2025 22:24:12 +0300
Subject: [PATCH 75/75] Rename aiguard.[ch] as daiguard.[ch]

See RM #1542

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 ai/default/Makefile.am               | 4 ++--
 ai/default/daidiplomat.c             | 2 +-
 ai/default/daiferry.c                | 2 +-
 ai/default/{aiguard.c => daiguard.c} | 2 +-
 ai/default/{aiguard.h => daiguard.h} | 6 +++---
 ai/default/daitools.c                | 2 +-
 ai/default/daiunit.c                 | 2 +-
 meson.build                          | 2 +-
 8 files changed, 11 insertions(+), 11 deletions(-)
 rename ai/default/{aiguard.c => daiguard.c} (99%)
 rename ai/default/{aiguard.h => daiguard.h} (96%)

diff --git a/ai/default/Makefile.am b/ai/default/Makefile.am
index b6eec6834f..3a90d158e9 100644
--- a/ai/default/Makefile.am
+++ b/ai/default/Makefile.am
@@ -15,8 +15,6 @@ AM_CPPFLAGS = \
 	-I$(top_srcdir)/gen_headers/enums
 
 libdefaultai_la_SOURCES = \
-		aiguard.c	\
-		aiguard.h	\
 		daiair.c	\
 		daiair.h	\
 		daiactions.c	\
@@ -35,6 +33,8 @@ libdefaultai_la_SOURCES = \
 		daieffects.h	\
 		daiferry.c	\
 		daiferry.h	\
+		daiguard.c	\
+		daiguard.h	\
 		daihand.c	\
 		daihand.h	\
 		daihunter.c	\
diff --git a/ai/default/daidiplomat.c b/ai/default/daidiplomat.c
index 2ebcb59fa8..dd87b2440d 100644
--- a/ai/default/daidiplomat.c
+++ b/ai/default/daidiplomat.c
@@ -60,10 +60,10 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiguard.h"
 #include "daiactions.h"
 #include "daicity.h"
 #include "daidata.h"
+#include "daiguard.h"
 #include "daihand.h"
 #include "dailog.h"
 #include "daimilitary.h"
diff --git a/ai/default/daiferry.c b/ai/default/daiferry.c
index 454f211e92..2d4fbf83ba 100644
--- a/ai/default/daiferry.c
+++ b/ai/default/daiferry.c
@@ -45,9 +45,9 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiguard.h"
 #include "daicity.h"
 #include "daidata.h"
+#include "daiguard.h"
 #include "daiplayer.h"
 #include "daitools.h"
 #include "daiunit.h"
diff --git a/ai/default/aiguard.c b/ai/default/daiguard.c
similarity index 99%
rename from ai/default/aiguard.c
rename to ai/default/daiguard.c
index 66e4246716..c331e58874 100644
--- a/ai/default/aiguard.c
+++ b/ai/default/daiguard.c
@@ -30,7 +30,7 @@
 #include "daiplayer.h"
 #include "daiunit.h"
 
-#include "aiguard.h"
+#include "daiguard.h"
 
 enum bodyguard_enum {
   BODYGUARD_WANTED = -1,
diff --git a/ai/default/aiguard.h b/ai/default/daiguard.h
similarity index 96%
rename from ai/default/aiguard.h
rename to ai/default/daiguard.h
index 47be023d81..598dbd6261 100644
--- a/ai/default/aiguard.h
+++ b/ai/default/daiguard.h
@@ -10,8 +10,8 @@
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 ***********************************************************************/
-#ifndef FC__AIGUARD_H
-#define FC__AIGUARD_H
+#ifndef FC__DAIGUARD_H
+#define FC__DAIGUARD_H
 
 #include "support.h"            /* bool type */
 
@@ -42,4 +42,4 @@ struct unit *aiguard_charge_unit(struct ai_type *ait, struct unit *guard);
 struct city *aiguard_charge_city(struct ai_type *ait, struct unit *guard);
 void aiguard_update_charge(struct ai_type *ait, struct unit *guard);
 
-#endif	/* FC__AIGUARD_H */
+#endif /* FC__DAIGUARD_H */
diff --git a/ai/default/daitools.c b/ai/default/daitools.c
index 070528f8a7..7b231ba56e 100644
--- a/ai/default/daitools.c
+++ b/ai/default/daitools.c
@@ -59,9 +59,9 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiguard.h"
 #include "daidata.h"
 #include "daiferry.h"
+#include "daiguard.h"
 #include "dailog.h"
 #include "daimilitary.h"
 #include "daiplayer.h"
diff --git a/ai/default/daiunit.c b/ai/default/daiunit.c
index 23ab119c47..7e42c9968e 100644
--- a/ai/default/daiunit.c
+++ b/ai/default/daiunit.c
@@ -66,13 +66,13 @@
 #include "handicaps.h"
 
 /* ai/default */
-#include "aiguard.h"
 #include "daiair.h"
 #include "daicity.h"
 #include "daidata.h"
 #include "daidiplomat.h"
 #include "daieffects.h"
 #include "daiferry.h"
+#include "daiguard.h"
 #include "daihunter.h"
 #include "dailog.h"
 #include "daimilitary.h"
diff --git a/meson.build b/meson.build
index 790f404b0c..3fc318c8bd 100644
--- a/meson.build
+++ b/meson.build
@@ -1524,7 +1524,6 @@ ais = static_library('fc_ai',
   'ai/tex/texaimsg.c',
   'ai/tex/texaiplayer.c',
   'ai/tex/texaiworld.c',
-  'ai/default/aiguard.c',
   'ai/default/daiair.c',
   'ai/default/daiactions.c',
   'ai/default/daicity.c',
@@ -1534,6 +1533,7 @@ ais = static_library('fc_ai',
   'ai/default/daidomestic.c',
   'ai/default/daieffects.c',
   'ai/default/daiferry.c',
+  'ai/default/daiguard.c',
   'ai/default/daihand.c',
   'ai/default/daihunter.c',
   'ai/default/dailog.c',
-- 
2.47.2